Index: trunk/NEMO/OPA_SRC/iom.F90
===================================================================
--- trunk/NEMO/OPA_SRC/iom.F90	(revision 507)
+++ trunk/NEMO/OPA_SRC/iom.F90	(revision 508)
@@ -200,142 +264,118 @@
          END DO
       ENDIF
-          
+      !    
    END SUBROUTINE iom_close
  
 
    !!----------------------------------------------------------------------
-   !!                   INTERFACE iom_u_getv
+   !!                   INTERFACE iom_get_123d
    !!----------------------------------------------------------------------
-   SUBROUTINE iom_get_r_1d( knumfl, kdom , cdvar , pvar  ,   &
-      &                             ktime, kstart, kcount )
-      INTEGER               , INTENT(in )           ::   knumfl    ! Identifier of the file
-      INTEGER               , INTENT(in )           ::   kdom      ! Type of domain to be read
-      CHARACTER(len=*)      , INTENT(in )           ::   cdvar     ! Name of the variable
-      REAL(wp), DIMENSION(:), INTENT(out)           ::   pvar      ! read field
-      INTEGER               , INTENT(in ) ,OPTIONAL ::   ktime     ! record number
-      INTEGER , DIMENSION(:), INTENT(in ), OPTIONAL ::   kstart    ! start position of the reading in each axis 
-      INTEGER , DIMENSION(:), INTENT(in ), OPTIONAL ::   kcount    ! number of points to be read in each axis
-!
-      CHARACTER(LEN=100) :: clinfo                    ! info character
-!
-      clinfo = 'iom_get_r_1d, file: '//trim(iom_file(knumfl)%name)//', var: '//trim(cdvar)
-      IF( PRESENT(kstart) ) THEN
-         IF ( SIZE(kstart) /= 1 ) CALL ctl_stop( trim(clinfo), 'kstart must be a 1 element vector' )
-      ENDIF
-      IF( PRESENT(kcount) ) THEN
-         IF ( SIZE(kcount) /= 1 ) CALL ctl_stop( trim(clinfo), 'kcount must be a 1 element vector' )
-      ENDIF
-      IF ( knumfl > 0 ) CALL iom_u_getv( knumfl, kdom       , cdvar        , pv_r1d=pvar,   &
-           &                                     ktime=ktime, kstart=kstart, kcount=kcount )
+   SUBROUTINE iom_get_r_0d( knumfl, cdvar, pvar )
+      INTEGER         , INTENT(in   )                 ::   knumfl    ! Identifier of the file
+      CHARACTER(len=*), INTENT(in   )                 ::   cdvar     ! Name of the variable
+      REAL(wp)        , INTENT(  out)                 ::   pvar      ! read field
+      !
+      IF( knumfl > 0 .AND. iom_varid( knumfl, cdvar ) > 0 )   CALL fliogetv( knumfl, cdvar, pvar )
+   END SUBROUTINE iom_get_r_0d
+
+   SUBROUTINE iom_get_r_1d( knumfl, kdom, cdvar, pvar, ktime, kstart, kcount )
+      INTEGER         , INTENT(in   )                         ::   knumfl    ! Identifier of the file
+      INTEGER         , INTENT(in   )                         ::   kdom      ! Type of domain to be read
+      CHARACTER(len=*), INTENT(in   )                         ::   cdvar     ! Name of the variable
+      REAL(wp)        , INTENT(  out), DIMENSION(:)           ::   pvar      ! read field
+      INTEGER         , INTENT(in   )              , OPTIONAL ::   ktime     ! record number
+      INTEGER         , INTENT(in   ), DIMENSION(1), OPTIONAL ::   kstart    ! start axis position of the reading 
+      INTEGER         , INTENT(in   ), DIMENSION(1), OPTIONAL ::   kcount    ! number of points in each axis
+      !
+      IF( knumfl > 0 ) CALL iom_get_123d( knumfl, kdom       , cdvar        , pv_r1d=pvar,   &
+         &                                        ktime=ktime, kstart=kstart, kcount=kcount )
    END SUBROUTINE iom_get_r_1d
-   SUBROUTINE iom_get_r_2d( knumfl, kdom , cdvar , pvar  ,   &
-      &                             ktime, kstart, kcount )
-      INTEGER,INTENT(in) :: knumfl
-      INTEGER,INTENT(in) :: kdom
-      CHARACTER(len=*),INTENT(in) :: cdvar
-      REAL(wp),INTENT(out),DIMENSION(:,:) :: pvar
-      INTEGER,INTENT(in),OPTIONAL :: ktime
-      INTEGER,DIMENSION(:),INTENT(in),OPTIONAL :: kstart
-      INTEGER,DIMENSION(:),INTENT(in),OPTIONAL :: kcount
-!
-      CHARACTER(LEN=100) :: clinfo                    ! info character
-!
-      clinfo = 'iom_get_r_2d, file: '//trim(iom_file(knumfl)%name)//', var: '//trim(cdvar)
-      IF( PRESENT(kstart) ) THEN
-         IF ( size(kstart) /= 2 ) CALL ctl_stop(trim(clinfo), 'kstart must be a 2 element vector')
-      ENDIF
-      IF( PRESENT(kcount) ) THEN
-         IF ( size(kcount) /= 2 ) CALL ctl_stop(trim(clinfo), 'kcount must be a 2 element vector')
-      ENDIF
-      IF ( knumfl > 0 ) CALL iom_u_getv( knumfl, kdom       , cdvar        , pv_r2d=pvar,   &
-         &                                       ktime=ktime, kstart=kstart, kcount=kcount )
+
+   SUBROUTINE iom_get_r_2d( knumfl, kdom, cdvar, pvar, ktime, kstart, kcount )
+      INTEGER         , INTENT(in   )                           ::   knumfl    ! Identifier of the file
+      INTEGER         , INTENT(in   )                           ::   kdom      ! Type of domain to be read
+      CHARACTER(len=*), INTENT(in   )                           ::   cdvar     ! Name of the variable
+      REAL(wp)        , INTENT(  out), DIMENSION(:,:)           ::   pvar      ! read field
+      INTEGER         , INTENT(in   )                , OPTIONAL ::   ktime     ! record number
+      INTEGER         , INTENT(in   ), DIMENSION(2)  , OPTIONAL ::   kstart    ! start axis position of the reading 
+      INTEGER         , INTENT(in   ), DIMENSION(2)  , OPTIONAL ::   kcount    ! number of points in each axis
+      !
+      IF( knumfl > 0 ) CALL iom_get_123d( knumfl, kdom       , cdvar        , pv_r2d=pvar,   &
+         &                                        ktime=ktime, kstart=kstart, kcount=kcount )
    END SUBROUTINE iom_get_r_2d
-   SUBROUTINE iom_get_r_3d( knumfl, kdom , cdvar , pvar  ,   &
-      &                             ktime, kstart, kcount )
-      INTEGER,INTENT(in) :: knumfl
-      INTEGER,INTENT(in) :: kdom
-      CHARACTER(len=*),INTENT(in) :: cdvar
-      REAL(wp),INTENT(out),DIMENSION(:,:,:) :: pvar
-      INTEGER,INTENT(in),OPTIONAL :: ktime
-      INTEGER,DIMENSION(:),INTENT(in),OPTIONAL :: kstart
-      INTEGER,DIMENSION(:),INTENT(in),OPTIONAL :: kcount
-!
-      CHARACTER(LEN=100) :: clinfo                    ! info character
-!
-      clinfo = 'iom_get_r_3d, file: '//trim(iom_file(knumfl)%name)//', var: '//trim(cdvar)
-      IF ( PRESENT(kstart) ) THEN
-         IF ( size(kstart) /= 3 ) CALL ctl_stop(trim(clinfo), 'kstart must be a 3 element vector')
-      ENDIF
-      IF ( PRESENT(kcount) ) THEN
-         IF ( size(kcount) /= 3 ) CALL ctl_stop(trim(clinfo), 'kcount must be a 3 element vector')
-      ENDIF
-      IF ( knumfl > 0 ) CALL iom_u_getv( knumfl, kdom       , cdvar        , pv_r3d=pvar,   &
-	     &                                   ktime=ktime, kstart=kstart, kcount=kcount )
+
+   SUBROUTINE iom_get_r_3d( knumfl, kdom, cdvar, pvar, ktime, kstart, kcount )
+      INTEGER         , INTENT(in   )                             ::   knumfl    ! Identifier of the file
+      INTEGER         , INTENT(in   )                             ::   kdom      ! Type of domain to be read
+      CHARACTER(len=*), INTENT(in   )                             ::   cdvar     ! Name of the variable
+      REAL(wp)        , INTENT(  out), DIMENSION(:,:,:)           ::   pvar      ! read field
+      INTEGER         , INTENT(in   )                  , OPTIONAL ::   ktime     ! record number
+      INTEGER         , INTENT(in   ), DIMENSION(3)    , OPTIONAL ::   kstart    ! start axis position of the reading 
+      INTEGER         , INTENT(in   ), DIMENSION(3)    , OPTIONAL ::   kcount    ! number of points in each axis
+      !
+      IF( knumfl > 0 ) CALL iom_get_123d( knumfl, kdom       , cdvar        , pv_r3d=pvar,   &
+         &                                        ktime=ktime, kstart=kstart, kcount=kcount )
    END SUBROUTINE iom_get_r_3d
    !!----------------------------------------------------------------------
 
-
-   SUBROUTINE iom_u_getv( knumfl, kdom  , cdvar , &
-        &                   pv_r1d, pv_r2d, pv_r3d, &
-        &                   ktime , kstart, kcount )
+   SUBROUTINE iom_get_123d( knumfl, kdom  , cdvar ,   &
+        &                   pv_r1d, pv_r2d, pv_r3d,   &
+        &                   ktime , kstart, kcount  )
      !!-----------------------------------------------------------------------
-     !!                  ***  ROUTINE  iom_u_getv  ***
+     !!                  ***  ROUTINE  iom_get_123d  ***
      !!
      !! ** Purpose : read a 1D/2D/3D variable
      !!
-     !! ** Method : read ONE time step at each CALL
-     !!
+     !! ** Method : read ONE record at each CALL
      !!-----------------------------------------------------------------------
-     INTEGER,                      INTENT(in )           ::   knumfl     ! Identifier of the file
-     INTEGER,                      INTENT(in )           ::   kdom       ! Type of domain to be read
-     CHARACTER(len=*),             INTENT(in )           ::   cdvar      ! Name of the variable
-     REAL(wp), DIMENSION(:)      , INTENT(out), OPTIONAL ::   pv_r1d     ! read field (1D case)
-     REAL(wp), DIMENSION(:,:)    , INTENT(out), OPTIONAL ::   pv_r2d     ! read field (2D case)
-     REAL(wp), DIMENSION(:,:,:)  , INTENT(out), OPTIONAL ::   pv_r3d     ! read field (3D case)
-     INTEGER                     , INTENT(in ), OPTIONAL ::   ktime      ! record number
-     INTEGER , DIMENSION(:)      , INTENT(in ), OPTIONAL ::   kstart     ! start position of the reading in each axis 
-     INTEGER , DIMENSION(:)      , INTENT(in ), OPTIONAL ::   kcount     ! number of points to be read in each axis
-
-     INTEGER                        :: jl            ! loop on number of dimension 
-     INTEGER                        :: idom,    &    ! type of domain
-          &                            idvar,   &    ! id of the variable
-          &                            inbdim,  &    ! number of dimensions of the variable
-          &                            idmspc,  &    ! number of spatial dimensions 
-          &                            itime,   &    ! record number
-          &                            istop         ! temporary value of nstop
-     INTEGER, DIMENSION(jpmax_dims) :: istart,  &    ! starting point to read for each axis
-          &                            icnt,    &    ! number of value to read along each axis 
-          &                            idimsz        ! size of the dimensions of the variable
-     REAL(wp)                       :: zscf, zofs    ! sacle_factor and add_offset
-     INTEGER                        ::  itmp         ! temporary integer
-     CHARACTER(LEN=100)             :: clinfo        ! info character
+     INTEGER                    , INTENT(in   )           ::   knumfl     ! Identifier of the file
+     INTEGER                    , INTENT(in   )           ::   kdom       ! Type of domain to be read
+     CHARACTER(len=*)           , INTENT(in   )           ::   cdvar      ! Name of the variable
+     REAL(wp), DIMENSION(:)     , INTENT(  out), OPTIONAL ::   pv_r1d     ! read field (1D case)
+     REAL(wp), DIMENSION(:,:)   , INTENT(  out), OPTIONAL ::   pv_r2d     ! read field (2D case)
+     REAL(wp), DIMENSION(:,:,:) , INTENT(  out), OPTIONAL ::   pv_r3d     ! read field (3D case)
+     INTEGER                    , INTENT(in   ), OPTIONAL ::   ktime      ! record number
+     INTEGER , DIMENSION(:)     , INTENT(in   ), OPTIONAL ::   kstart     ! start position of the reading in each axis 
+     INTEGER , DIMENSION(:)     , INTENT(in   ), OPTIONAL ::   kcount     ! number of points to be read in each axis
+     !
+     INTEGER                        ::   jl          ! loop on number of dimension 
+     INTEGER                        ::   idom,    &  ! type of domain
+          &                              idvar,   &  ! id of the variable
+          &                              inbdim,  &  ! number of dimensions of the variable
+          &                              idmspc,  &  ! number of spatial dimensions 
+          &                              itime,   &  ! record number
+          &                              istop       ! temporary value of nstop
+     INTEGER, DIMENSION(jpmax_dims) ::   istart,  &  ! starting point to read for each axis
+          &                              icnt,    &  ! number of value to read along each axis 
+          &                              idimsz      ! size of the dimensions of the variable
+     REAL(wp)                       ::   zscf, zofs  ! sacle_factor and add_offset
+     INTEGER                        ::   itmp        ! temporary integer
+     CHARACTER(LEN=100)             ::   clinfo      ! info character
      !---------------------------------------------------------------------
-     clinfo = 'iom_u_getv, file: '//trim(iom_file(knumfl)%name)//', var: '//trim(cdvar)
+     !
+     clinfo = '          iom_get_123d, file: '//trim(iom_file(knumfl)%name)//', var: '//trim(cdvar)
      ! local definition of the domain ?
      idom = kdom
      ! check kcount and kstart optionals parameters...
-     IF( PRESENT(kcount) .AND. (.NOT. PRESENT(kstart)) ) &
+     IF( PRESENT(kcount) .AND. (.NOT. PRESENT(kstart)) )   &
           CALL ctl_stop( trim(clinfo), 'kcount present needs kstart present' )
-     IF( PRESENT(kstart) .AND. (.NOT. PRESENT(kcount)) ) &
+     IF( PRESENT(kstart) .AND. (.NOT. PRESENT(kcount)) )   &
           CALL ctl_stop( trim(clinfo), 'kstart present needs kcount present' )
-     IF( PRESENT(kstart) .AND. idom /= jpdom_unknown ) &
+     IF( PRESENT(kstart) .AND. idom /= jpdom_unknown   )   &
           CALL ctl_stop( trim(clinfo), 'kstart present needs kdom = jpdom_unknown' )
 
      ! Search for the variable in the data base (eventually actualize data)
-     !-
      istop = nstop
      idvar = iom_varid( knumfl, cdvar )
      !
-     IF ( idvar > 0 ) THEN
+     IF( idvar > 0 ) THEN
         ! to write iom_file(knumfl)%dimsz in a shorter way !
         idimsz(:) = iom_file(knumfl)%dimsz(:, idvar) 
-        inbdim = iom_file(knumfl)%ndims(idvar)! number of dimensions in the file
-        idmspc = inbdim ! number of spatial dimensions in the file
-        IF( iom_file(knumfl)%luld(idvar) ) idmspc = inbdim - 1
-        IF( idmspc > 3 ) CALL ctl_stop(trim(clinfo), 'the file has more than 3 spatial dimensions',   &
-             &                    'this case is not coded...') 
-        ! Identify the domain in case of jpdom_local definition
-        !-
-        IF( idom == jpdom_local ) THEN
+        inbdim = iom_file(knumfl)%ndims(idvar)            ! number of dimensions in the file
+        idmspc = inbdim                                   ! number of spatial dimensions in the file
+        IF( iom_file(knumfl)%luld(idvar) )   idmspc = inbdim - 1
+        IF( idmspc > 3 )   CALL ctl_stop(trim(clinfo),   &
+           &                    'the file has more than 3 spatial dimensions this case is not coded...' ) 
+        IF( idom == jpdom_local ) THEN        ! Identify the domain in case of jpdom_local definition
            IF( idimsz(1) == jpi .AND. idimsz(2) == jpj ) THEN 
               idom = jpdom_local_full
@@ -348,10 +388,10 @@
            ENDIF
         ENDIF
-
+        !
         ! definition of istart and icnt
-        !-
+        !
         ! initializations
         istart(:) = 1
-        icnt(:) = 1
+        icnt  (:) = 1
         itime = 1
         IF( PRESENT(ktime) ) itime = ktime
@@ -383,5 +423,5 @@
            CASE (2)
               ! data is 2d array (+ maybe a temporal dimension)
-              IF ( PRESENT(kstart) ) THEN
+              IF( PRESENT(kstart) ) THEN
                  istart(1:3) = (/ kstart(1:2), itime /)
                  icnt(1:2) = kcount(1:2)
@@ -404,9 +444,9 @@
               ENDIF
            CASE DEFAULT
-              IF ( itime == 1 .AND. idimsz(3) == 1 .AND. idmspc == 3 ) THEN
-                 CALL ctl_warn( trim(clinfo), '2D array but 3 spatial dimensions for the data...', &
-                      &         'As the size of the z dimension is 1 and as we try to read the first reacord, ',     &
-                      &         'we accept this case even if there is a possible mix-up between z and time dimension...')           
-                 IF ( PRESENT(kstart) ) THEN
+              IF( itime == 1 .AND. idimsz(3) == 1 .AND. idmspc == 3 ) THEN
+                 CALL ctl_warn( trim(clinfo), '2D array but 3 spatial dimensions for the data...',                &
+                      &         'As the size of the z dimension is 1 and as we try to read the first record, ',   &
+                      &         'we accept this case even if there is a possible mix-up between z and time dimension' )           
+                 IF( PRESENT(kstart) ) THEN
                     istart(1:2) = kstart(1:2)
                     icnt(1:2) = kcount(1:2)
@@ -428,18 +468,18 @@
                  ENDIF
               ELSE
-                 CALL ctl_stop( trim(clinfo), 'to keep iom lisibility, when reading a 2D array,', &
-                      &         'we do not accept data with more than 2 spatial dimension',     &
-                      &         'Use ncwa -a to suppress the unnecessary dimensions')           
+                 CALL ctl_stop( trim(clinfo), 'to keep iom lisibility, when reading a 2D array,',           &
+                      &                       'we do not accept data with more than 2 spatial dimension',   &
+                      &                       'Use ncwa -a to suppress the unnecessary dimensions' )
               ENDIF
            END SELECT
         ELSEIF( PRESENT(pv_r3d) ) THEN
            SELECT CASE (idmspc)
-           CASE (1)
-              CALL ctl_stop(trim(clinfo), 'the file has only 1 spatial dimension',   &
-                   &        'it is impossible to read a 3d array from this file...')
-           CASE (2)
-              CALL ctl_stop(trim(clinfo), 'the file has only 2 spatial dimension',   &
-                   &        'it is impossible to read a 3d array from this file...')
-           CASE (3)
+           CASE( 1 )
+              CALL ctl_stop( trim(clinfo), 'the file has only 1 spatial dimension',            &
+                   &                       'it is impossible to read a 3d array from this file...' )
+           CASE( 2 )
+              CALL ctl_stop( trim(clinfo), 'the file has only 2 spatial dimension',            &
+                   &                       'it is impossible to read a 3d array from this file...' )
+           CASE( 3 )
               ! data is 3d array (+ maybe a temporal dimension)
               IF( PRESENT(kstart) ) THEN
@@ -469,7 +509,7 @@
               ENDIF
            CASE DEFAULT
-              CALL ctl_stop( trim(clinfo), 'to keep iom lisibility, when reading a 3D array,', &
-                   &         'we do not accept data with more than 3 spatial dimension',     &
-                   &         'Use ncwa -a to suppress the unnecessary dimensions')           
+              CALL ctl_stop( trim(clinfo), 'to keep iom lisibility, when reading a 3D array,',   &
+                   &         'we do not accept data with more than 3 spatial dimension',         &
+                   &         'Use ncwa -a to suppress the unnecessary dimensions' )           
            END SELECT
         ENDIF
@@ -491,5 +531,5 @@
            itmp = size(pv_r1d)
            WRITE(ctmp1,*) 'size(pv_r1d): ', itmp, ' /= icnt(1): ', icnt(1)
-           IF( itmp /= icnt(1) ) CALL ctl_stop( trim(clinfo), ctmp1 )
+           IF( itmp /= icnt(1) )   CALL ctl_stop( trim(clinfo), ctmp1 )
         ELSEIF( PRESENT(pv_r2d) ) THEN
            DO jl = 1, 2
@@ -501,5 +541,5 @@
                  WRITE(ctmp1,*) 'size(pv_r2d(nldi:nlei,nldj:nlej), ',jl,'): ',itmp,' /= icnt(',jl,'): ',icnt(jl)
               ENDIF
-              IF( itmp /= icnt(jl) ) CALL ctl_stop( trim(clinfo), ctmp1 )
+              IF( itmp /= icnt(jl) )   CALL ctl_stop( trim(clinfo), ctmp1 )
            END DO
         ELSEIF( PRESENT(pv_r3d) ) THEN
@@ -512,5 +552,5 @@
                  WRITE(ctmp1,*) 'size(pv_r3d(nldi:nlei,nldj:nlej), ',jl,'): ',itmp,' /= icnt(',jl,'): ',icnt(jl)
               ENDIF
-              IF( itmp /= icnt(jl) ) CALL ctl_stop( trim(clinfo), ctmp1 )
+              IF( itmp /= icnt(jl) )   CALL ctl_stop( trim(clinfo), ctmp1 )
            END DO
         ENDIF
@@ -520,6 +560,4 @@
      !-     
      IF( istop == nstop) THEN ! no additional errors until this point...
-        !
-        istop = nstop
         !
         zscf = iom_file(knumfl)%scf(idvar)      ! scale factor
@@ -529,12 +567,14 @@
            CALL fliogetv( knumfl, cdvar, pv_r1d(:), start=istart(1:inbdim), count=icnt(1:inbdim) )
            !--- Apply scale_factor and offset
-           IF( zscf /= 1. ) pv_r1d(:) = pv_r1d(:) * zscf 
-           IF( zofs /= 0. ) pv_r1d(:) = pv_r1d(:) + zofs
+           IF( zscf /= 1. )   pv_r1d(:) = pv_r1d(:) * zscf 
+           IF( zofs /= 0. )   pv_r1d(:) = pv_r1d(:) + zofs
         ELSEIF( PRESENT(pv_r2d) ) THEN
            IF( idom /= jpdom_unknown ) THEN
               CALL fliogetv( knumfl, cdvar, pv_r2d(nldi:nlei,nldj:nlej), start=istart(1:inbdim), count=icnt(1:inbdim) )
               !--- Apply scale_factor and offset
-              IF (zscf /= 1.) pv_r2d(nldi:nlei, nldj:nlej) = pv_r2d(nldi:nlei,nldj:nlej) * zscf
-              IF (zofs /= 0.) pv_r2d(nldi:nlei, nldj:nlej) = pv_r2d(nldi:nlei,nldj:nlej) + zofs
+!CDIR NOUNROLL
+              IF( zscf /= 1.)   pv_r2d(nldi:nlei, nldj:nlej) = pv_r2d(nldi:nlei,nldj:nlej) * zscf
+!CDIR NOUNROLL
+              IF( zofs /= 0.)   pv_r2d(nldi:nlei, nldj:nlej) = pv_r2d(nldi:nlei,nldj:nlej) + zofs
               !--- Fill the overlap areas and extra hallows (mpp)
               CALL lbc_lnk (pv_r2d,'Z',-999.,'no0')
@@ -542,13 +582,18 @@
               CALL fliogetv( knumfl, cdvar, pv_r2d(:,:), start=istart(1:inbdim), count=icnt(1:inbdim) )
               !--- Apply scale_factor and offset
-              IF (zscf /= 1.) pv_r2d(:,:) = pv_r2d(:,:) * zscf
-              IF (zofs /= 0.) pv_r2d(:,:) = pv_r2d(:,:) + zofs
+!CDIR COLLAPSE
+              IF( zscf /= 1.)   pv_r2d(:,:) = pv_r2d(:,:) * zscf
+!CDIR COLLAPSE
+              IF( zofs /= 0.)   pv_r2d(:,:) = pv_r2d(:,:) + zofs
            ENDIF
         ELSEIF( PRESENT(pv_r3d) ) THEN
            IF( idom /= jpdom_unknown ) THEN
-              CALL fliogetv( knumfl, cdvar, pv_r3d(nldi:nlei,nldj:nlej,:), start=istart(1:inbdim), count=icnt(1:inbdim) )
+              CALL fliogetv( knumfl, cdvar, pv_r3d(nldi:nlei,nldj:nlej,:), start=istart(1:inbdim),   &
+                 &                                                         count=icnt  (1:inbdim) )
               !--- Apply scale_factor and offset
-              IF( zscf /= 1. ) pv_r3d(nldi:nlei,nldj:nlej,:) = pv_r3d(nldi:nlei,nldj:nlej,:) * zscf
-              IF( zofs /= 0. ) pv_r3d(nldi:nlei,nldj:nlej,:) = pv_r3d(nldi:nlei,nldj:nlej,:) + zofs
+!CDIR NOUNROLL
+              IF( zscf /= 1. )   pv_r3d(nldi:nlei,nldj:nlej,:) = pv_r3d(nldi:nlei,nldj:nlej,:) * zscf
+!CDIR NOUNROLL
+              IF( zofs /= 0. )   pv_r3d(nldi:nlei,nldj:nlej,:) = pv_r3d(nldi:nlei,nldj:nlej,:) + zofs
               !--- Fill the overlap areas and extra hallows (mpp)
               IF( icnt(3) == jpk )   CALL lbc_lnk( pv_r3d,'Z',-999.,'no0' ) ! this if could be removed with the new lbc_lnk ...
